// 11/15/2003 - Finished
// 03/12/2006 - Replaced MAPLINE with CMapLine

#include "MapConvert.h"

typedef struct
{
	USHORT iNum;
	USHORT iDoom;
	BYTE iLevel;
	SHORT iAngle;
	BOOL bMoving;
} MONSTER_CONVERSION;

class CPrefabs
{
protected:
	static INT m_iLightLevel;
	static CHAR m_szCeiling[16];
	static CHAR m_szFloor[16];
	static BOOL m_bUpperPanels;
	static VERTEX m_vSquare[];
	static VERTEX m_vOuter[];
	static VERTEX m_vMiddle[];
	static MONSTER_CONVERSION m_MonsterTable[];
	static MONSTER_CONVERSION m_MonsterTableTC[];

public:
	static VOID SetLightLevel (INT iLightLevel);
	static VOID SetFlats (LPSTR lpszFloor, LPSTR lpszCeiling);
	static VOID SetUpperPanels (BOOL bUpperPanels);

	static VOID CreateColumn (CMapConvert* lpMap, INT sParent, INT x, INT y, INT iType);
	static VOID ExtendOutside (CMapConvert* lpMap, CMapLine* lpLine, INT iDir, LPSTR lpszTexture);
	static VOID CreateOilDrum (CMapConvert* lpMap, INT sParent, INT x, INT y);
	static VOID CreateBarrel (CMapConvert* lpMap, INT sParent, INT x, INT y);

	static BOOL ConvertActor (CMapThing* lpThing, USHORT iType);
	static BOOL ConvertActorTC (CMapThing* lpThing, USHORT iType);
	static VOID CreateSpear (CMapConvert* lpMap, INT sParent, INT x, INT y);

protected:
	static VOID CreateCylinder (CMapConvert* lpMap, INT sParent, INT x, INT y, LPSTR lpszSides, LPSTR lpszTop, LPSTR lpszCenter, INT iSideHeight, INT iCenterHeight);
	static LONG LineLength (CMapLine* lpLine);
	static VOID BuildLines (LPVERTEX lpVertex, FLOAT fScale, CMapLine* lpLines, INT cList, INT x, INT y);
	static VOID AlignRightTexture (CMapLine* lpLines, INT cList, INT cWidth);
};