#include <windows.h>
#include "resource.h"
#include "LightLevelDlg.h"

CLightLevelDlg::CLightLevelDlg (HINSTANCE hInstance) : CQuickDialog(IDD_LIGHT_LEVEL,hInstance)
{
	m_iLightLevel = 160;
}

CLightLevelDlg::~CLightLevelDlg ()
{
}

VOID CLightLevelDlg::SetLightLevel (INT iLightLevel)
{
	if(iLightLevel >= 0)
		m_iLightLevel = iLightLevel;
}

INT CLightLevelDlg::GetLightLevel (VOID)
{
	return m_iLightLevel;
}

VOID CLightLevelDlg::DlgCreate (VOID)
{
	CHAR szLight[32];

	m_hLightLevel = GetDlgItem(IDC_LIGHT_LEVEL);

	_itoa(m_iLightLevel,szLight,10);
	SetWindowText(m_hLightLevel,szLight);
}

VOID CLightLevelDlg::DlgCommand (USHORT id, USHORT iCode)
{
	CHAR szLight[32];

	switch(id)
	{
	case IDOK:
		if(GetWindowTextLength(m_hLightLevel) > 0)
		{
			INT iLight;

			GetWindowText(m_hLightLevel,szLight,32);
			iLight = atoi(szLight);

			if(iLight >= 0 && iLight <= 255)
			{
				m_iLightLevel = iLight;
				End(TRUE);
			}
			else
				MessageBox(GetSelf(),"The light level must be between 0 and 255.","Invalid Light Level",MB_OK);
		}
		break;
	case IDCANCEL:
		End(FALSE);
		break;
	}
}