#include <windows.h>
#include "resource.h"
#include "..\MapConvert.h"
#include "..\WolfMap.h"
#include "OpenWolfDlg.h"

COpenWolfDlg::COpenWolfDlg (HINSTANCE hInstance, CWolfMap* lpMap) : CQuickDialog(IDD_OPEN_WOLF,hInstance)
{
	m_lpMap = lpMap;

	m_szHead[0] = 0;
	m_szData[0] = 0;
}

COpenWolfDlg::~COpenWolfDlg ()
{
}

VOID COpenWolfDlg::SetPaths (LPSTR lpszHead, LPSTR lpszData)
{
	lstrcpy(m_szHead,lpszHead);
	lstrcpy(m_szData,lpszData);
}

VOID COpenWolfDlg::GetPaths (LPSTR lpszHead, LPSTR lpszData)
{
	lstrcpy(lpszHead,m_szHead);
	lstrcpy(lpszData,m_szData);
}

VOID COpenWolfDlg::DlgCreate (VOID)
{
	HWND hInfo = GetDlgItem(IDC_INFO);

	if(m_lpMap->IsOpen())
		SetWindowText(hInfo,"Files are ready to convert");
	else
		SetWindowText(hInfo,"No map files have been opened yet");

	m_hHead = GetDlgItem(IDC_MAP_HEAD);
	m_hData = GetDlgItem(IDC_MAP_DATA);

	SetWindowText(m_hHead,m_szHead);
	SetWindowText(m_hData,m_szData);
}

VOID COpenWolfDlg::DlgCommand (USHORT id, USHORT iCode)
{
	INT c;
	CWolfMap* lpTest;
	switch(id)
	{
	case IDOK:
		c = GetWindowTextLength(m_hHead);
		if(c == 0 || c > 255)
			break;
		c = GetWindowTextLength(m_hData);
		if(c == 0 || c > 255)
			break;
		GetWindowText(m_hHead,m_szHead,256);
		GetWindowText(m_hData,m_szData,256);
		lpTest = new CWolfMap;
		if(lpTest->Init(m_szHead,m_szData))
			End(TRUE);
		else
			MessageBox(GetSelf(),"Could not open files!","Error",MB_OK);
		delete lpTest;
		break;
	case IDCANCEL:
		End(FALSE);
		break;
	}
}