// 11/15/2003 - Finished
// 03/12/2006 - Added ability to change conversion format
// 07/09/2006 - Added ability to allow floor zero

#include <windows.h>
#include <stdio.h>
#include "WolfMap.h"
#include "MapConvert.h"

BOOL GetParam (LPSTR lpszParam, LPSTR lpszValue, LPSTR lpszDefault = NULL)
{
	BOOL bSuccess = TRUE;
	LPSTR lpszCmd = GetCommandLine();
	LPSTR lpszFind = strstr(lpszCmd,lpszParam);
	if(lpszFind)
	{
		CHAR chEnd = 32, *lpszEnd;
		lpszFind += lstrlen(lpszParam);
		while(*lpszFind == 32)
			lpszFind++;
		if(*lpszFind == '"')
		{
			lpszFind++;
			chEnd = '"';
		}
		lpszEnd = strchr(lpszFind,chEnd);
		if(lpszEnd)
		{
			*lpszEnd = 0;
			if(lpszValue)
				lstrcpy(lpszValue,lpszFind);
			*lpszEnd = chEnd;
		}
		else if(lpszValue)
			lstrcpy(lpszValue,lpszFind);
	}
	else if(lpszDefault)
	{
		if(lpszValue)
			lstrcpy(lpszValue,lpszDefault);
	}
	else
		bSuccess = FALSE;
	return bSuccess;
}

VOID main (INT argc, LPSTR argv[])
{
	CHAR szHead[_MAX_PATH], szData[_MAX_PATH], szMap[16];
	CHAR szName[10], szOutput[_MAX_PATH], szFormat[8];

	if(GetParam("-?",NULL) || GetParam("/?",NULL))
		printf("Parameters\n -head    MAPHEAD.WL6\n -data    GAMEMAPS.WL6\n -map    \"Wolf1 Map1\"\n -name    MAP01\n -output    MYFILE.WAD\n-format    DOOM/ZDOOM/ZDOOMTC\n");
	else
	{
#ifdef _DEBUG
		GetParam("-head",szHead,"D:\\Wolf3d\\maphead.wl6");
		GetParam("-data",szData,"D:\\Wolf3d\\gamemaps.wl6");
#else
		GetParam("-head",szHead,"maphead.wl6");
		GetParam("-data",szData,"gamemaps.wl6");
#endif

		GetParam("-map",szMap,"Wolf1 Map1");
		GetParam("-name",szName,"MAP01");
		GetParam("-output",szOutput,"WOLFMAP.WAD");
		GetParam("-format",szFormat,"DOOM");

		CWolfMap* lpWolfMap = new CWolfMap;
		if(lpWolfMap->Init(szHead,szData))
		{
			LPMAPDATA lpMap = lpWolfMap->GetMap(szMap);
			if(lpMap)
			{
				CMapConvert Convert;

				if(lstrcmpi(szFormat,"DOOM") == 0)
					Convert.SetConversionType(CTYPE_DOOM);
				else if(lstrcmpi(szFormat,"ZDOOM") == 0)
					Convert.SetConversionType(CTYPE_ZDOOM);
				else if(lstrcmpi(szFormat,"ZDOOMTC") == 0)
					Convert.SetConversionType(CTYPE_ZDOOMTC);
				else if(lstrcmpi(szFormat,"BSTC") == 0)
					Convert.SetConversionType(CTYPE_BSTC);
				else if(lstrcmpi(szFormat,"EDGE") == 0)
					Convert.SetConversionType(CTYPE_EDGE);

				if(Convert.GetConversionType() != CTYPE_INVALID)
				{
					Convert.AllowFloorZero(GetParam("-FloorZero",NULL));

					if(Convert.RunConversion(szName,szOutput,lpMap->Floor,lpMap->Object,TRUE))
						printf("SUCCESS: Conversion complete\n");
					else
						printf("ERROR: Unexpected error or failure\n");
				}
				else
					printf("ERROR: Invalid format specified\n");

				lpWolfMap->FreeMap(lpMap);
			}
			else
				printf("ERROR: Could not load map\n");
		}
		else
			printf("ERROR: Could not read map files\n");
		delete lpWolfMap;
	}
}